<?
error_reporting(E_ALL);
ini_set('display_errors', 1);

function get_frame($frame_name)
{
	global $frames;
	if (!isset ($frames[$frame_name]))
	{return False;}
	$frame = $frames[$frame_name];
	foreach ($frames['default'] as $key=>$value)
	{
		if (!isset($frame[$key]))
		{$frame[$key]=$value;}
	}
	$frame['name'] = $frame_name;
	return $frame;
}

if (
	! isset($_GET['frame']) or ! isset($_GET['size']) or ! isset($_GET['img_file_name']) 
	)
{die;}

$refresh = isset($_GET['refresh']);
$frame_name = $_GET['frame'];
$size = $_GET['size'];
$img_file_name = rawurldecode( preg_replace("/^\/+/","/",$_GET['img_file_name']) );

$frames = array(
	'none' => array(
					'bg'	=> "#ffffff",
					'border' => "",
					'bordercolor' => "",
					'shadow' => '2%',
					),

	'shadowed' => array(
					'bg'	=> "#ffffff",
					'border' => "1.5% 1",
					'bordercolor' => "#ffffff #cccccc",
					'shadow' => '2%',
					),
	
	'default' => array(
					'frame'			=> 'sharp shadow',
					'bg'			=> "#ffffff",
					'output_type'	=>'jpg',					
					'sizes' 		=> array(25,40,35,50,80,100,200,400,500,"100x71","500x375","142x100","80x57","50x35"), #500x375 
					'bg'			=> "#ffffff",
					'border'		=> "2.5% 1",
					'bordercolor'	=> "#ffffff #cccccc",
					'shadow'		=> '2.5%',
					'default_size'  => '100w',
					),
	'shadowed_stack' =>	array(
					'bg'	=> "#ffffff",
					'border' => "1.5% 1",
					'bordercolor' => "#ffffff #cccccc",
					'shadow' => '2%',
					'rotation' => 20,
					'move' => 15,
					'stack' => 5,
					'sizes'	=> array(300,239),
					),
	'forum_header' =>	array(
					'background-image'	=> "/forum/styles/prosilver/theme/images/bg_header.gif",
					'border' => "1",
					'output_type'	=>'png',
					'bordercolor' => "#ffffff",
					'shadow' => 2,
					'rotation' => 10,
					'sizes'	=> array("100x82"),
					),

	
	
	);
	
if (
	! $frame = get_frame($frame_name) or
	! file_exists("$_SERVER[DOCUMENT_ROOT]/$img_file_name") 
	# Add critical options here 
   ) 
{die;} 


# Set size types 
function set_size($size)
{
	global $width, $height, $thumbtype;
	if (preg_match('/^((\d+)x)?(\d+)(f|c)$/',$size,$matches))
	{	
		if ($matches[4]=='f') 
		{$thumbtype = 'fit';}
		elseif ($matches[4]=='c') 
		{$thumbtype = 'crop';}
		if (!isset($matches[2]) or $matches[2]=='')
		{$width = intval($matches[3]);}
		else
		{$width = intval($matches[2]);}
		$height = intval($matches[3]);
	}
	elseif(preg_match('/^(\d+)(w|h)$/',$size,$matches))	
	{
		if ($matches[2]=='w') 
		{	
			$width = intval($matches[1]);
			$height = 0;
			$thumbtype = 'width';
		}
		elseif ($matches[2]=='h') 
		{	
			$width = 0;
			$height = intval($matches[1]);
			$thumbtype = 'height';
		}
	}
	else
	{return False;}
	return True;
}




if (
	!set_size($size) or
	
	($width!=0 and $height!=0 and !in_array("{$width}x$height",$frame['sizes']))
	or 
	(
		($width==0 or $height==0)
		and
		(
			($width!=0 and !in_array($width,$frame['sizes']))
			or
			($height!=0 and !in_array($height,$frame['sizes']))
		)
	)
	or
	($width==0 and $height==0)
   )
{
	$size = $frame['default_size'];
	set_size($frame['default_size']);
}

$img=pathinfo($img_file_name);
$cache=preg_replace('/^-+/','',preg_replace('/\/|\./','-',preg_replace('/-/','--',$img_file_name)));
$cache="$_SERVER[DOCUMENT_ROOT]/custom_scripts/data/image/$frame_name/{$width}x{$height}_$thumbtype/{$cache}.$frame[output_type]";


if ( !file_exists($cache) or $refresh )
{	
	$img_file_name="$_SERVER[DOCUMENT_ROOT]/$img_file_name";
	$img_file_name= preg_replace('/\.\.\//','',$img_file_name);
	$img_file_name= preg_replace('/\/\//','/',$img_file_name);
	
	if (file_exists($cache))  {unlink($cache);}
	if ( ! $image = new Imagick($img_file_name) )
	{die;}	


	function set_w_and_h($image,$width,$height,$thumbtype)
	{
		$geometry = $image->getImageGeometry();
		$wi = $geometry['width'];
		$hi = $geometry['height'];
		if ($wi==0 or $hi==0)
		{die;}

		# set w and h of result image 
		if ($thumbtype=='width' or ($thumbtype=='fit' and $height/$hi>$width/$wi))
		{
			$w = $width;
			$h = intval(round($width*$hi/$wi));
			$size_ = $w;
		}
		elseif ($thumbtype=='height' or $thumbtype=='fit')
		{
			$h = $height;
			$w = intval(round($height*$wi/$hi));
			$size_ = $h;		
		}
		elseif ($thumbtype=='crop')
		{
			$h = $height;
			$w = $width;
			$size_ = $w;		
		}
		
		$GLOBALS['size_'] = $size_;
		$GLOBALS['w'] = $w;
		$GLOBALS['h'] = $h;
	}
	
	if (!is_dir(dirname($cache)))
	{
		$a=explode("/",dirname($cache));
		$dir='';
		foreach($a as $value)
		{
			$dir.="/$value";
			if (!is_dir($dir))
			{mkdir($dir);}
		}
	}

	# get shadow width
	function set_shadow_and_borders(&$frame,$size_)
	{
		if(isset($frame['shadow']))
		{
			if (preg_match("/([\-0-9\.,]+)(\%)?/",$frame['shadow'],$matches))
			{
				$frame['shadow'] = (isset($matches[2])) ? round(floatval($matches[1])*$size_/100) : intval($matches[1]) ;
			}
			else
			{$frame['shadow'] = 0;}
		}
	
	
		# get borders 
	
		if (isset($frame['border']))
		{
			$border = array();
			$bordercolor = array();
			# Create borders
			foreach (preg_split("/\s+/","$frame[border]") as $s)
			{
				if (preg_match("/([\-0-9\.,]+)(%)?/",$s,$matches))
				{
					$b = (isset($matches[2])) ? ceil(floatval($matches[1])*$size_/100) : intval($matches[1]) ;
					$border[] = $b;
				}
			}
			foreach (preg_split("/\s+/","$frame[bordercolor]") as $i)
			{$bordercolor[] = $i;}
			$frame['border'] = $border;
			$frame['bordercolor'] = $bordercolor;
		
		}
	}
	
	############################################################################
	#	Shadowed frame
	############################################################################
	if ($frame['name']=='shadowed')
	{
		set_w_and_h($image,$width,$height,$thumbtype);
		# save final image dimentions
		$w_ = $w;
		$h_ = $h;
		set_shadow_and_borders(&$frame,$size_);
		$w -= $frame["shadow"]*4;
		$h -= $frame["shadow"]*4;
		$w -= array_sum($frame['border'])*2;
		$h -= array_sum($frame['border'])*2;
		
		$image->setImageVirtualPixelMethod(imagick::VIRTUALPIXELMETHOD_WHITE);
		$image->cropThumbnailImage($w,$h);
		for ($i=0; $i<count($frame['border']); $i++)
		{$image->borderImage($frame['bordercolor'][$i],$frame['border'][$i],$frame['border'][$i]);}
		# Create Shadow
		$shadow = $image->clone();
		$shadow->setImageBackgroundColor( new ImagickPixel( "#777777" ) );
		$shadow->shadowImage( 50, $frame['shadow'],1,1 );
		$shadow->compositeImage( $image, Imagick::COMPOSITE_OVER, $frame['shadow']*1.5,$frame['shadow']*1.5);

		# Create BG							
		$bg = new Imagick();
		$bg->newImage($w_, $h_, new ImagickPixel($frame['bg']),"png");
		$bg->compositeImage( $shadow, Imagick::COMPOSITE_OVER, 0,0);
		$bg->writeImage($cache);
	}
	
	############################################################################
	#	Shadowed_stack frame
	############################################################################
	elseif ($frame['name']=='shadowed_stack')
	{
		set_w_and_h($image,$width,$height,$thumbtype);
		set_shadow_and_borders(&$frame,$size_);
		# contract w and h to fit frame size 
		# movement compensation
		$dw = $frame['move'];
		$dh = $frame['move'];
		# rotation compensation
		$a = $frame['rotation']/2*pi()/180;
		$x = $w/2*cos($a) - $h/2*sin($a);  
		$y = $w/2*sin($a) + $h/2*cos($a); 
		$dw += abs($w-2*$x);
		$dh += abs($h-2*$y);

		# contract w and h to fit borders and shadow (dw_inner)
		$dw_i = $frame["shadow"]*4;
		$dh_i = $frame["shadow"]*4;
		$dw_i += array_sum($frame['border'])*2;
		$dh_i += array_sum($frame['border'])*2;

		
		# now reset $w and $h whith $width-$dw and $height-$dh
		set_w_and_h($image,max(0,$width-$dw-$dw_i),max($height-$dh-$dh_i,0),$thumbtype);

		# save final image dimentions
		$w_ = $w+$dw+$dw_i;
		$h_ = $h+$dh+$dw_i;

		
		#create image ordianry shadowed image 
	

		$image->setImageVirtualPixelMethod(imagick::VIRTUALPIXELMETHOD_WHITE);
		$image->cropThumbnailImage($w,$h);
		for ($i=0; $i<count($frame['border']); $i++)
		{$image->borderImage($frame['bordercolor'][$i],$frame['border'][$i],$frame['border'][$i]);}
		# Create Shadow
		$shadow = $image->clone();
		$shadow->setImageBackgroundColor( new ImagickPixel( "#777777" ) );
		$shadow->shadowImage( 50, $frame['shadow'],1,1 );
		$shadow->compositeImage( $image, Imagick::COMPOSITE_OVER, $frame['shadow']*1.5,$frame['shadow']*1.5);

		# Create BG							
		$bg = new Imagick();
		$bg->newImage($w_, $h_, new ImagickPixel($frame['bg']),"png");

				
		for ($i=0; $i<$frame['stack']-1;$i++)
		{
			$stack = $shadow->clone();
			$stack->rotateImage('transparent' , rand(0,100)*$frame['rotation']/100-$frame['rotation']/2);
			$bg->compositeImage( $stack, Imagick::COMPOSITE_OVER, $dw/2+rand(0,100)*$frame['move']/100-$frame['move']/2, $dh/2+rand(0,100)*$frame['move']/100-$frame['move']/2);
			$stack->destroy();
		}

		$bg->compositeImage($shadow, Imagick::COMPOSITE_OVER, $dw/2, $dh/2);
		
		$bg->writeImage($cache);
		
	}
	
	############################################################################
	#	Forum Header Thumbs frame
	############################################################################
	elseif ($frame['name']=='forum_header')
	{
		set_w_and_h($image,$width,$height,$thumbtype);
		set_shadow_and_borders(&$frame,$size_);
	
		# rotation compensation
		$a = $frame['rotation']/2*pi()/180;
		$x = $w/2*cos($a) - $h/2*sin($a);  
		$y = $w/2*sin($a) + $h/2*cos($a); 
		$dw = abs($w-2*$x);
		$dh = abs($h-2*$y);
	
		# contract w and h to fit borders and shadow (dw_inner)
		$dw_i = $frame["shadow"]*4;
		$dh_i = $frame["shadow"]*4;
		$dw_i += array_sum($frame['border'])*2;
		$dh_i += array_sum($frame['border'])*2;

		# now reset $w and $h whith $width-$dw and $height-$dh
		set_w_and_h($image,max(0,$width-$dw-$dw_i),max($height-$dh-$dh_i,0),$thumbtype);

		# save final image dimentions
		$w_ = $w+$dw+$dw_i;
		$h_ = $h+$dh+$dw_i;

		$image->setImageVirtualPixelMethod(imagick::VIRTUALPIXELMETHOD_WHITE);
		$image->cropThumbnailImage($w,$h);
		for ($i=0; $i<count($frame['border']); $i++)
		{$image->borderImage($frame['bordercolor'][$i],$frame['border'][$i],$frame['border'][$i]);}
		# Create Shadow
		$shadow = $image->clone();
		$shadow->setImageBackgroundColor( new ImagickPixel( "#000000" ) );
		
		$shadow->shadowImage( 50, $frame['shadow'],1,1 );
		
		$shadow->compositeImage( $image, Imagick::COMPOSITE_OVER, $frame['shadow']*1.5,$frame['shadow']*1.5);
		$shadow->rotateImage('transparent' , rand(0,100)*$frame['rotation']/100-$frame['rotation']/2);

		# Create BG							
		$bg = new Imagick($_SERVER['DOCUMENT_ROOT'].$frame['background-image']);
		$geometry = $bg->getImageGeometry();
		$bg_w = $geometry['width'];
		$bg_h = $geometry['height'];
		$bg->cropImage($bg_w,$bg_h-10,0,5);
		$bg_h -= 10;

		
		$bg->scaleImage($w_, $bg_h, false);
#		echo "$w $bg_h ";
#		die;
		$bg->compositeImage( $shadow, Imagick::COMPOSITE_OVER, $dw/2, $dh/2);
		$bg->setImageFormat('png');
		$bg->writeImage($cache);
	}
	elseif ($frame['name']=='none')
	{
		set_w_and_h($image,$width,$height,$thumbtype);
		$image->cropThumbnailImage($w,$h);		
		$image->writeImage($cache);
	}

	
}
					
if ($frame['output_type']=='png')
{header('Content-type: image/png');}
else
{header('Content-type: image/jpeg');}

readfile("$cache");


?>
